.NOLIST
.INCLUDE "tn2313def.inc"
.LIST

; r0 reserved for data indexing
.def	temp1 	= r16
.def	temp2 	= r17
.def	temp3 	= r18
.def	Td1		= r19
.def	Td2		= r20
.def	Td3		= r21
.def	poA		= r22
.def	poB		= r23
.def	indexL	= r24
.def	indexH	= r25
.def	Status	= r26	; bit0=direction
.def	cnt		= r27

; r30, r31 reserved for data indexing
.equ	Tmax	= 8
.equ	repeat	= 25

; Code starts here
.CSEG
.ORG $0000

rjmp RESET			; Reset Handler
;rjmp INT0 			; External Interrupt0 Handler
;rjmp INT1			; External Interrupt1 Handler
;rjmp TIM1_CAPT 	; Timer1 Capture Handler
;rjmp TIM1_COMPA	; Timer1 CompareA Handler
;rjmp TIM1_OVF 		; Timer1 Overflow Handler
;rjmp TIM0_OVF 		; Timer0 Overflow Handler
;rjmp USART0_RXC 	; USART0 RX Complete Handler
;rjmp USART0_DRE 	; USART0,UDR Empty Handler
;rjmp USART0_TXC 	; USART0 TX Complete Handler
;rjmp ANA_COMP 		; Analog Comparator Handler
;rjmp PCINT 		; Pin Change Interrupt
;rjmp TIMER1_COMPB	; Timer1 Compare B Handler
;rjmp TIMER0_COMPA	; Timer0 Compare A Handler
;rjmp TIMER0_COMPB	; Timer0 Compare B Handler
;rjmp USI_START		; USI Start Handler
;rjmp USI_OVERFLOW	; USI Overflow Handler
;rjmp EE_READY		; EEPROM Ready Handler
;rjmp WDT_OVERFLOW	; Watchdog Overflow Handler

;INT0:				; External Interrupt0 Handler
;reti 
;INT1:				; External Interrupt1 Handler
;reti 
;TIM1_CAPT:		 	; Timer1 Capture Handler
;reti
;TIM1_COMPA:	 	; Timer1 CompareA Handler
;reti
;TIM1_OVF:	 		; Timer1 Overflow Handler
;reti
;TIM0_OVF:			; Timer0 Overflow Handler
;reti
;USART0_RXC:		; USART0 RX Complete Handler
;reti
;USART0_DRE:		; USART0,UDR Empty Handler
;reti
;USART0_TXC:		; USART0 TX Complete Handler
;reti
;ANA_COMP:			; Analog Comparator Handler
;reti
;PCINT:				; Pin Change Interrupt
;reti
;TIMER1_COMPB:		; Timer1 Compare B Handler
;reti
;TIMER0_COMPA:		; Timer0 Compare A Handler
;reti
;TIMER0_COMPB:		; Timer0 Compare B Handler
;reti
;USI_START:			; USI Start Handler
;reti
;USI_OVERFLOW:	 	; USI Overflow Handler
;reti
;EE_READY:	 		; EEPROM Ready Handler
;reti
;WDT_OVERFLOW:	 	; Watchdog Overflow Handler
;reti

; **************** End of interrupt service routines ***********
sdel:	ser		temp1
		ser		temp2
sdel1:	dec		temp1
		brne	sdel1
		ser		temp1
		dec		temp2
		brne	sdel1
		ret
; ******************** Main program ********************************

RESET:	ldi r16, low(RAMEND)	; Main program start
		out SPL,r16 			; Set Stack Pointer to top of RAM

		clr		temp1
		ser		temp2
		out		ddrA,temp1
		out		ddrB,temp2
		out		ddrD,temp1
		out		portA,temp2
		out		portD,temp2

arxi:	clr		poB
arx1:	out		portB,poB
		rcall	sdel
		inc		poB
		rjmp	arx1

